#pragma once

#ifdef TUSB0416DAM_EXPORTS
#define TUSB0416DAM_API __declspec(dllexport) __stdcall
#else
#define TUSB0416DAM_API __declspec(dllexport) __stdcall
#endif

typedef	ULONG	TU_STATUS;

// DACݒ\
typedef	struct
{
	UINT8 Mode;			//샂[h 0:Œlo 1:Ag`Q[g 2:Ag`gK 3:FIFO
	UINT8 ClkSel;		//Ag`̎̃NbN\[X 0: 1:O
	UINT8 GTSel;		//Ag`̎̃Q[g/gK\[X 0: 1:O
	UINT8 ExGtInv;		//OQ[gM_] 0:]Ȃ(Low̎o) 1:] Q[g̎̂݁@gK̏ꍇ͔]Ȃ
	UINT8 Rstc;			//g`o̓[hQ[g̎ɃQ[g~ĂуQ[gJnɂȂɔg`JE^Zbg邩@0: 1:Ȃ
	UINT8 Option;		//IvV@\@\ 0ݒ肷
	UINT8 FStat[2];		//g`o͒~̏ԑI(2ch) 0:g`̍ŏIl 1:~o͎wl
	UINT16 FVal[2];		//g`~o͎wl(2ch)
	UINT16 RepCyc;		//gKg`o͉ 0~65535 (0̎͐Ȃ)
}stSettings;

#ifdef __cplusplus
extern "C" {
#endif

	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Connect(LPCSTR SerialNumber);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_DisConnect(LPCSTR SerialNumber);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Dio_Dir(LPCSTR SerialNumber, UINT8 DirData);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Dio_Dir_R(LPCSTR SerialNumber, UINT8 *DirData);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Dio_In(LPCSTR SerialNumber, UINT8 *InData);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Dio_Out(LPCSTR SerialNumber, UINT8 OutData);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Dio_Out_R(LPCSTR SerialNumber, UINT8 *OutData);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Exs_Sel(LPCSTR SerialNumber, UINT8 OutSel0, UINT8 OutSel1);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Clock_Gen(LPCSTR SerialNumber, UINT8 MSel, UINT32 DivideN);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_DacGrSet(LPCSTR SerialNumber, UINT8 MSel, stSettings* Damset);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_DacGrSet_R(LPCSTR SerialNumber, UINT8 MSel, stSettings* Damset);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_WavImgSet(LPCSTR SerialNumber, UINT8 MSel, UINT16 *WImage1, UINT16 *WImage2, INT32 Len);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Fifo_ImgSet(LPCSTR SerialNumber, UINT8 Ch, UINT16 *WImage, INT32 Len);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Fifo_Clr(LPCSTR SerialNumber, UINT8 Ch);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Fifo_Status(LPCSTR SerialNumber, UINT8 *Over, UINT8 *Under, UINT32 *DataLen);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Trigger(LPCSTR SerialNumber, UINT8 MSel, UINT8 SSel);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_Trigger_Stat(LPCSTR SerialNumber, UINT8 MSel, UINT8 *Stat);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_GateSet(LPCSTR SerialNumber, UINT8 MSel, UINT8 GateEn);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_GateSet_R(LPCSTR SerialNumber, UINT8 MSel, UINT8 *GateEn);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_RangeSet(LPCSTR SerialNumber, UINT8 Ch, UINT8 Range);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_RangeSet_R(LPCSTR SerialNumber, UINT8 Ch, UINT8 *Range);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_DcValSet(LPCSTR SerialNumber, UINT8 Ch, UINT16 NVal);
	TU_STATUS TUSB0416DAM_API TUSB0416DAM_DcValSet_R(LPCSTR SerialNumber, UINT8 Ch, UINT16 *NVal);

#ifdef __cplusplus
}
#endif
